/////////////////////////////////////////////////////////////////////
//
// Scientific Component PortController ver. 1.0
// Copyright 2003 Scientific Component
// http://www.scientificcomponent.com
// 
/////////////////////////////////////////////////////////////////////

// SCPortCtrlEventSink.h: interface for the CSCPortCtrlEventSink class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MYSINK_H__A6C538A9_EA84_47F9_B975_F26AE623B972__INCLUDED_)
#define AFX_MYSINK_H__A6C538A9_EA84_47F9_B975_F26AE623B972__INCLUDED_

#include <atlbase.h>
#include <atlcom.h>

#import "SCPortControlMod.dll" named_guids, no_namespace

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

////////////////////////////////////////////
// Messages
////////////////////////////////////////////
static UINT SCPC_BREAK = RegisterWindowMessage("WM_SCPC_BREAK");
static UINT SCPC_CTSTOGGLE = RegisterWindowMessage("WM_SCPC_CTSTOGGLE");
static UINT SCPC_DSRTOGGLE = RegisterWindowMessage("WM_SCPC_DSRTOGGLE");
static UINT SCPC_CDTOGGLE = RegisterWindowMessage("WM_SCPC_CDTOGGLE");
static UINT SCPC_ERROR = RegisterWindowMessage("WM_SCPC_ERROR");
static UINT SCPC_RING = RegisterWindowMessage("WM_SCPC_RING");
static UINT SCPC_DATAREC = RegisterWindowMessage("WM_SCPC_DATAREC");
static UINT SCPC_TQEMPTY = RegisterWindowMessage("WM_SCPC_TQEMPTY");
static UINT SCPC_EVTCHARREC = RegisterWindowMessage("WM_SCPC_EVTCHARREC");
static UINT SCPC_TEST = RegisterWindowMessage("WM_SCPC_TEST");


class CSCPortCtrlEventSink : public IDispEventImpl<1, CSCPortCtrlEventSink,
         &DIID__IPortControllerEvents, &LIBID_SCPORTCONTROLMODLib, 1, 0> 
{
public:
	HWND m_parentWnd;

	/////////////////////////////////////////////////////////
	// Sink map entries
	/////////////////////////////////////////////////////////
	BEGIN_SINK_MAP(CSCPortCtrlEventSink)
		SINK_ENTRY_EX(1, DIID__IPortControllerEvents, 0x1, OnBreakSignal)
		SINK_ENTRY_EX(1, DIID__IPortControllerEvents, 0x2, OnCtsToggle)
		SINK_ENTRY_EX(1, DIID__IPortControllerEvents, 0x3, OnDsrToggle)
		SINK_ENTRY_EX(1, DIID__IPortControllerEvents, 0x4, OnCdToggle)
		SINK_ENTRY_EX(1, DIID__IPortControllerEvents, 0x5, OnError)
		SINK_ENTRY_EX(1, DIID__IPortControllerEvents, 0x6, OnRing)
		SINK_ENTRY_EX(1, DIID__IPortControllerEvents, 0x7, OnDataReceived)
		SINK_ENTRY_EX(1, DIID__IPortControllerEvents, 0x8, OnTQEmpty)
		SINK_ENTRY_EX(1, DIID__IPortControllerEvents, 0x9, OnEvtCharReceived)
		SINK_ENTRY_EX(1, DIID__IPortControllerEvents, 0xb, OnTestEvent)
    END_SINK_MAP()


	CSCPortCtrlEventSink::CSCPortCtrlEventSink(HWND parentWnd)
	{
		m_parentWnd = parentWnd;
	}

	CSCPortCtrlEventSink::~CSCPortCtrlEventSink()
	{

	}


	////////////////////////////////////////
	// Message posting functions
	////////////////////////////////////////
	HRESULT __stdcall CSCPortCtrlEventSink::OnBreakSignal()
	{
		PostMessage(m_parentWnd, SCPC_BREAK, NULL, NULL);
		return S_OK;
	}

	HRESULT __stdcall CSCPortCtrlEventSink::OnCtsToggle(short CtsState)
	{
		PostMessage(m_parentWnd, SCPC_CTSTOGGLE, CtsState, NULL);
		return S_OK;
	}

	HRESULT __stdcall CSCPortCtrlEventSink::OnDsrToggle(short DsrState)
	{
		PostMessage(m_parentWnd, SCPC_DSRTOGGLE, DsrState, NULL);
		return S_OK;
	}

	HRESULT __stdcall CSCPortCtrlEventSink::OnCdToggle(short CdState)
	{
		PostMessage(m_parentWnd, SCPC_CDTOGGLE, CdState, NULL);
		return S_OK;
	}


	HRESULT __stdcall CSCPortCtrlEventSink::OnError()
	{
		PostMessage(m_parentWnd, SCPC_ERROR, NULL, NULL);
		return S_OK;
	}

	HRESULT __stdcall CSCPortCtrlEventSink::OnRing()
	{
		PostMessage(m_parentWnd, SCPC_RING, NULL, NULL);
		return S_OK;
	}

	HRESULT __stdcall CSCPortCtrlEventSink::OnDataReceived()
	{
		PostMessage(m_parentWnd, SCPC_DATAREC, NULL, NULL);
		return S_OK;
	}

	HRESULT __stdcall CSCPortCtrlEventSink::OnTQEmpty()
	{
		PostMessage(m_parentWnd, SCPC_TQEMPTY, NULL, NULL);
		return S_OK;
	}

	HRESULT __stdcall CSCPortCtrlEventSink::OnEvtCharReceived(BSTR ReadBuffer, long NumBytesReceived)
	{
		SendMessage(m_parentWnd, SCPC_EVTCHARREC, (WPARAM)ReadBuffer, (LPARAM)NumBytesReceived);
		return S_OK;
	}

	HRESULT __stdcall CSCPortCtrlEventSink::OnTestEvent()
	{
		PostMessage(m_parentWnd, SCPC_TEST, NULL, NULL);
		return S_OK;
	}

};

#endif // !defined(AFX_MYSINK_H__A6C538A9_EA84_47F9_B975_F26AE623B972__INCLUDED_)
