#ifndef CMD_THREAD_H
#define CMD_THREAD_H

#include <qmainwindow.h>
#include <qstring.h>
#include <qthread.h>
#include <qlabel.h>
#include <qdialog.h>
#include <qmessagebox.h>
#include <qslider.h>
#include <qtimer.h>
#include <qtextview.h>

#include <stdio.h>
#include <stdlib.h>
#include <process.h>

#include <windows.h>						// findwindow + HWND
///#include <conio.h>					// LPT
///#include <dos.h>

#include "serial.h"						// port serie (1 thread)


#include "lcd.h"
#include "ktv.h"
#include "mediaPlayer.h"
#include "winamp.h"

enum {
	TEL_TUNER = 100,
	TEL_AUX,
	TEL_CD,
	TEL_TAPE,
	TEL_DCC,
	TEL_PHONO
};

//---------------------------------------------------------------------------
// Thread pour lire les parametres de Winamp toutes les x milli-secondes
//---------------------------------------------------------------------------
class CommandThread : public QThread {

  public:
		CommandThread(QDialog *dialog);
		~CommandThread();
		void setLblTitre(QLabel *lblTitre, QLabel *lblInfo, QTextView* TxtEeprom);
		void setRefresh(unsigned int msec);
		void setPortCom(SerialCOM * portCom);

		// Code Infrarouge
		unsigned long TelecoIR(int *touche, int menu);

		// Update Afficheur LCD
		void WinampMenu(void);
		// Menu Heure Systeme
		void DateMenu(void);
		// Menu Temperature (+ heure)
		void TemperatureMenu(void);

		// Update IHM PC
		void WinampMenuIHMPC(unsigned long codeir);
		

		virtual void run();
	   virtual void stop();
  protected:
	   QLabel * _lblTitre;
	   QLabel * _lblInfo;
		QTextView* _txtEeprom;
		QDialog *_dialog;				// pour fct hide show (masquer IHM PC)
		int _stopThread;
		unsigned int _msec;
		int _track;
		SerialCOM * _portCom;
		Lcd * _lcd;						// afficheur LCD
		FILE * _FstdErr;
	 	WinampCmd _winCMD;
		int hLast, mLast, sLast;	// heure precedante pour effacer aiguilles
		unsigned char _pwm;			// valeur pwm backlight
};

#define M_PI 3.1415926535897//932384626433832795

#endif