#include "winamp.h"

//---------------------------------------------------------------------------
// Constructeur / Destructeur
//---------------------------------------------------------------------------
WinampCmd::WinampCmd(void)
{
	getWinamp();
	_volume = 127;
	_volMute = 0;	// UnMute
	
}

// recupere Winamp
void
WinampCmd::getWinamp(void) {
	_hwndWinamp = FindWindow("Winamp v1.x",NULL);			// cherche fenetre Winamp v2.x ou v1.x
	if (_hwndWinamp == NULL)  { _hwndWinamp = FindWindow("Winamp v2.x", NULL); } // Winamp v3.x
	if (_hwndWinamp == NULL)  { _hwndWinamp = FindWindow(NULL, "Winamp"); }
	///if (_hwndWinamp==NULL) perror("Erreur Winamp introuvable");
}


//  Destroys the object and frees any allocated resources
WinampCmd::~WinampCmd()
{

}

//---------------------------------------------------------------------------
int 
WinampCmd::winampFound(void)
{
	if (_hwndWinamp == NULL) return 0;
	else return 1;
}

//---------------------------------------------------------------------------
/*void 
WinampCmd::setSliderVolume(QSlider *SliderVolume) {
	_SliderVolume = SliderVolume;
}*/


//---------------------------------------------------------------------------
void
WinampCmd::getTitle(QString & str) 
{
	char this_title[1024]; //, *p;
	GetWindowText(_hwndWinamp, this_title, 1024);//sizeof(this_title));
	
	 // remove ' - Winamp' if found at end
	 if (strlen(this_title) > 9)
	 {
		 int check_pos = strlen(this_title) - 9;
		 if (lstrcmp(" - Winamp", (char *)(this_title + check_pos)) == 0)
			 this_title[check_pos] = 0;
	 }

	 // remove ' - Winamp [Paused]' if found at end
	 if (strlen(this_title) > 18)
	 {
		 int check_pos = strlen(this_title) - 18;
		 if (lstrcmp(" - Winamp [Paused]", (char *)(this_title + check_pos)) == 0)
			 this_title[check_pos] = 0;
	 }
	 if (strlen(this_title) > 18)
	 {
		 int check_pos = strlen(this_title) - 19;
		 if (lstrcmp(" - Winamp [Stopped]", (char *)(this_title + check_pos)) == 0)
			 this_title[check_pos] = 0;
	 }

	str = QString(this_title);//p);//
	//###### Virer Npiste avec replace? + -Winamp [stop][pause]
	int idxPointName;
	idxPointName = str.find(".", 0, TRUE);
	str = str.mid(idxPointName+2);
	// Remplacement des accents et caracteres speciaux
	str.replace(QRegExp("[]"), "e" );           
	str.replace(QRegExp("[]"), "E" );           
	str.replace(QRegExp("[]"), "A" );           
	str.replace(QRegExp("[]"), "a" );           
	str.replace(QRegExp("[]"), "u" );           
	str.replace(QRegExp("[]"), "i" );           
	str.replace(QRegExp("[]"), "U" );           
	str.replace(QRegExp(""), "o" );           
	str.replace(QRegExp(""), "c" );           
	str.replace(QRegExp(""), "C" );           
	str.replace(QRegExp(""), "n" );           
	str.replace(QRegExp(".mp3"), "" );           
	str.replace(QRegExp("Artiste inconnu - "), "" );           
	str.replace(QRegExp("Unknown Artist - "), "" );           
	str.replace(QRegExp("Inconnu - "), "" );           
	/*str.replace(QRegExp(" - Winamp"), "" );           
	str.replace(QRegExp("^[^][Stopped]"), "" );           
	str.replace(QRegExp("^[^][Paused]"), "" );*/           
}

//---------------------------------------------------------------------------
void
WinampCmd::cmdPlay(void) 
{
	// int ret=SendMessage(hwndWinamp,WM_USER, data, id); 
	//	SendMessage(_hwndWinamp,WM_WA_IPC,0,IPC_STARTPLAY);	// OK
	// Using IPC_STARTPLAY is like hitting 'Play' in Winamp, mostly.
	int status;
	status = SendMessage(_hwndWinamp, WM_USER, 0, 104);	
	switch (status) {
		case WINAMP_STATUS_PLAY :
		case WINAMP_STATUS_PAUSE :
				SendMessage(_hwndWinamp,WM_COMMAND, WINAMP_PAUSE_UNPAUSE_BUTTON,0);
				break;
		case WINAMP_STATUS_STOP :
		default :
				SendMessage(_hwndWinamp, WM_COMMAND, WINAMP_PLAY_BUTTON,0);
	}
}


//---------------------------------------------------------------------------
void 
WinampCmd::cmdPrevious()
{
	SendMessage(_hwndWinamp, WM_COMMAND, WINAMP_PREVIOUS_TRACK_BUTTON,0);
}

//---------------------------------------------------------------------------
void 
WinampCmd::cmdNext()
{
	SendMessage(_hwndWinamp, WM_COMMAND, WINAMP_NEXT_TRACK_BUTTON,0);
}

//---------------------------------------------------------------------------
void 
WinampCmd::cmdStop()
{
	SendMessage(_hwndWinamp, WM_COMMAND, WINAMP_STOP_BUTTON,0);
}

//---------------------------------------------------------------------------
void
WinampCmd::cmdVolume(unsigned char volume)
{
	if (_volMute==1) {
		SendMessage(_hwndWinamp,WM_WA_IPC,0,IPC_SETVOLUME);
	}
	else {
		SendMessage(_hwndWinamp,WM_WA_IPC,volume,IPC_SETVOLUME);
		_volume = volume;
		///if (_SliderVolume!=NULL) _SliderVolume->setValue(55);//_volume);
	}
// IPC_SETVOLUME sets the volume of Winamp (from 0-255).
}

//---------------------------------------------------------------------------
void
WinampCmd::cmdIncVolume(void)
{
	if (_volume+16 < 255) _volume+=16;
	else _volume = 255;
	cmdVolume(_volume);
}

//---------------------------------------------------------------------------
void
WinampCmd::cmdDecVolume(void)
{
	if (_volume-16 > 0) _volume-=16;
	else _volume = 0;
	cmdVolume(_volume);
}

//---------------------------------------------------------------------------
void 
WinampCmd::cmdMuteVolume(void)
{
	if (_volMute==1) _volMute = 0;
	else _volMute = 1;
	cmdVolume(_volume);
}


//---------------------------------------------------------------------------
// fast forwards 5 seconds
void 
WinampCmd::cmdForward(void) {
	SendMessage(_hwndWinamp, WM_COMMAND, WINAMP_FFWD5S, 0);
}

//---------------------------------------------------------------------------
// rewinds 5 seconds
void 
WinampCmd::cmdRewind(void) {
	SendMessage(_hwndWinamp, WM_COMMAND, WINAMP_REW5S, 0);
}

//---------------------------------------------------------------------------
// Permmute Random (Shuffle)
void 
WinampCmd::cmdShuffle(void) {
	SendMessage(_hwndWinamp, WM_COMMAND, WINAMP_TOGGLE_SHUFFLE, 0);
	/*int val;
	val=SendMessage(_hwndWinamp,WM_WA_IPC,0,IPC_GET_SHUFFLE);
	if (val!=0) val = 0;
	else val = 1;
	SendMessage(_hwndWinamp,WM_WA_IPC,val,IPC_SET_SHUFFLE);*/
}

//---------------------------------------------------------------------------
void 
WinampCmd::cmdFullScreen(void) {
	SendMessage(_hwndWinamp, WM_COMMAND, 40165, 65536);		// CTRL+D
}

//---------------------------------------------------------------------------
int
WinampCmd::getSampleRate()	// 44KHz
{
	return SendMessage(_hwndWinamp, WM_WA_IPC, 0, IPC_GETINFO);
// IPC_GETINFO returns info about the current playing song. The value
}

//---------------------------------------------------------------------------
int
WinampCmd::getBitRate()	// 128 000 Bps
{
	return SendMessage(_hwndWinamp, WM_WA_IPC, 1, IPC_GETINFO);
}

//---------------------------------------------------------------------------
int
WinampCmd::getChannels()	// 2CH
{
	return SendMessage(_hwndWinamp, WM_WA_IPC, 2, IPC_GETINFO);
}


//---------------------------------------------------------------------------
// Temps courant de la chanson
void 
WinampCmd::getSongPosAsText(char *szSongPos)
{
    // note: size(szSongPos[]) must be at least 64.
	szSongPos[0] = 0;
	int nSongPosMS = SendMessage(_hwndWinamp,WM_USER,0,105);
    if (nSongPosMS > 0)
    {
		float time_s = nSongPosMS*0.001f;
		int minutes = (int)(time_s/60);
		time_s -= minutes*60;
		int seconds = (int)time_s;
		time_s -= seconds;
		int dsec = (int)(time_s*100);
		sprintf(szSongPos, "%d:%02d.%02d", minutes, seconds, dsec);
    }    
}

//---------------------------------------------------------------------------
// Temps courant de la chanson
void 
WinampCmd::getSongPosAsNum(char *min, char *sec, char *msec)
{
	int nSongPosMS = SendMessage(_hwndWinamp,WM_USER,0,105);
    if (nSongPosMS > 0)
    {
		float time_s = nSongPosMS*0.001f;
		int minutes = (int)(time_s/60);
		time_s -= minutes*60;
		int seconds = (int)time_s;
		time_s -= seconds;
		int dsec = (int)(time_s*100);
		*min = minutes;
		*sec = seconds;
		*msec = dsec;
   }    
}


//---------------------------------------------------------------------------
// Temps total de la chanson
void 
WinampCmd::getSongLenAsText(char *szSongLen)
{
    // note: size(szSongLen[]) must be at least 64.
	int nSongLenMS = SendMessage(_hwndWinamp,WM_USER,1,105)*1000;
	if (nSongLenMS > 0)
	{
		int len_s = nSongLenMS/1000;
		int minutes = len_s/60;
		int seconds = len_s - minutes*60;
		sprintf(szSongLen, "%d:%02d", minutes, seconds);
	}    
}


//---------------------------------------------------------------------------
// Temps total de la chanson
void 
WinampCmd::getSongLenAsNum(char *min, char *sec)
{
	int nSongLenMS = SendMessage(_hwndWinamp,WM_USER,1,105)*1000;
	if (nSongLenMS > 0)
	{
		int len_s = nSongLenMS/1000;
		int minutes = len_s/60;
		int seconds = len_s - minutes*60;
		*min = minutes;
		*sec = seconds;
	}    
}

//----------------------------------------------------------------------------
// int getTrackData(int *iTrackNum, int *iStatus, char **pszTrackName)
//
// Given pointers to two ints and a char pointer (you can pass NULL if a piece
// of information isn't needed) getTrackData() retrieves the track number and
// a pointer to the name of the current track, and the current state of Winamp
// (1 = playing, 3 = paused, all else indicates stopped.)
//
// Must be used by a Winamp plugin ONLY.
//----------------------------------------------------------------------------
void 
WinampCmd::getTrackData(int *iTrackNum, int *iStatus, char *buf)//char **pszTrackName)
{
	int i, /*j,*/ k;

	i = SendMessage(_hwndWinamp, WM_USER, 0, 125) + 1;		// i = track number
///	j = SendMessage(_hwndWinamp, WM_USER, i, 212);     // j = track name ptr
	k = SendMessage(_hwndWinamp, WM_USER, 0, 104);		// k = status

	if (NULL != iTrackNum)     { *iTrackNum = i; }
	if (NULL != iStatus)       { *iStatus = k; }
///	if (NULL != pszTrackName)  { *pszTrackName = (char *) j; }//BUG ok dans vis ??

////	char buf[1024];
////	strcpy(buf, (char*)SendMessage(_hwndWinamp, WM_USER, i, 212));

}

//----------------------------------------------------------------------------
// Chargement Playlist a partir du CD-ROM
//----------------------------------------------------------------------------
void
WinampCmd::loadPlaylist(char * file) {

	// clear Winamp's internal playlist.
	//SendMessage(_hwndWinamp,WM_WA_IPC,0,IPC_DELETE);	// OK

	//SendMessage(_hwndWinamp, WM_COMMAND, 40029,0);	// ouvre load file winamp

	//SendMessage(_hwndWinamp, WM_COMMAND, 40187,0);	// ouvre load directory winamp	=> ok
	//SendMessage(_hwndWinamp, WM_COMMAND, 40185,0);	// ouvre play location

	//SendMessage(_hwndWinamp, WM_COMMAND, 40323,0);		// Play premier lecteur CD : OK mais AUDIO !!
	// 40234 Play 2nd lecteur CD ...

	
	// appel un nouveau processus detache avec parametre playlist
	_spawnl(_P_DETACH, "E:\\Program Files\\Winamp\\Winamp.exe", "Winamp.exe", "D:\\xp.m3u", NULL); // new process
}

