#ifndef WINAMP_H
#define WINAMP_H

#include "frontend.h"					// Winamp Control CMD

#include <stdio.h>
#include <stdlib.h>
#include <process.h>
#include <windows.h>						// findwindow + HWND



#include <qstring.h>
#include <qregexp.h>

//---------------------------------------------------------------------------
// Classe de commande de Winamp : Play/pause/next/previous/volume + nom Chanson
//---------------------------------------------------------------------------
class WinampCmd //: public QWidget
{
//	Q_OBJECT
	public:
		WinampCmd(void);
		void getWinamp(void);// recupere Winamp
		~WinampCmd();
		int winampFound(void);
		//void setSliderVolume(QSlider *SliderVolume);
		void getTitle(QString & str) ;
		void cmdPlay(void) ;
		void cmdPrevious();
		void cmdNext();
		void cmdStop();
		void cmdVolume(unsigned char volume);
		void cmdIncVolume(void);
		void cmdDecVolume(void);
		void cmdMuteVolume(void);
		void cmdForward(void);
		void cmdRewind(void);
		void cmdShuffle(void);// Permmute Random (Shuffle)
		void cmdFullScreen(void);


		int getVolume(){return _volume;}	// INTERNE PAS VOLUME DE WINAMP
		int getSampleRate();
		int getBitRate();
		int getChannels();
		int getMute(){return _volMute;}


		// Temps courant de la chanson
		void getSongPosAsText(char *szSongPos);
		void getSongPosAsNum(char *min, char *sec, char *msec);
		// Temps total de la chanson
		void getSongLenAsText(char *szSongLen);
		void getSongLenAsNum(char *min, char *sec);

		void getTrackData(int *iTrackNum, int *iStatus, char *buf);//char **pszTrackName);

		// Chargement Playlist a partir du CD-ROM
		void loadPlaylist(char * file);



	private:
		HWND _hwndWinamp;
		unsigned char _volume;
		int _volMute;
		//QSlider* _SliderVolume;
};


#endif
